=== debian/changelog ===
undertaker (1.1-2ubuntu1) oneiric; urgency=low

  * debian/patches/fix-as-needed-build.patch:
    - fix build with ld --as-needed (LP: #803209)

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Sun, 21 Aug 2011 17:05:37 +0200

undertaker (1.1-2) unstable; urgency=low

  * Apply patch from Konstantinos Margaritis for building against newer
    boost (Closes: #625007)

 -- Christoph Egger <christoph@debian.org>  Sat, 25 Jun 2011 16:04:36 +0200

undertaker (1.1-1) unstable; urgency=low

  * New upstream Version
  * Change siretart's E-Mail address
  * Fix copyright information
  * Add Vcs-* Headers

 -- Christoph Egger <christoph@debian.org>  Thu, 10 Feb 2011 22:26:20 +0100

undertaker (1.0-1) unstable; urgency=low

  * Initial release (Closes: #611178)

 -- Christoph Egger <christoph@debian.org>  Wed, 12 Jan 2011 14:51:00 +0100
