=== debian/control ===
Source: undertaker
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Christoph Egger <christoph@debian.org>
Uploaders: Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper (>= 7.0.50~),
 picosat (>= 913-4~),
 libboost-wave-dev (>= 1.40),
 libboost-regex-dev (>= 1.40),
 libboost-filesystem-dev (>= 1.40),
 libboost-dev (>= 1.40),
 check
Standards-Version: 3.9.1
Homepage: http://vamos.informatik.uni-erlangen.de/trac/undertaker
Vcs-Git: git://git.debian.org/git/collab-maint/undertaker.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/undertaker.git

Package: undertaker
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 git
Description: static code analysis tool checking preprocessor directives
 The undertaker is an preprocessor and configuration analyser. It can
 check the structure of your preprocessor directives against different
 configuration models to find blocks than can't be selected or
 deselected.

Package: undertaker-el
Architecture: all
Depends: ${shlibs:Depends},
 ${misc:Depends},
 emacsen | emacs23,
 undertaker
Description: emacs integration for undertaker
 undertaker-mode allows you to get the preprocessor condition under
 which the selected line of source code is built optionally incuding
 restrictions from a external configuration model
