=== debian/rules ===
#!/usr/bin/make -f

%:
	dh  $@

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

override_dh_auto_test:
	$(MAKE) -C rsf2model check
	$(MAKE) -C undertaker run-libcheck
	$(MAKE) -C ziz check
