=== undertaker/Makefile ===
--- 
+++ 
@@ -7,20 +7,22 @@
 # DEBUG = -g3 -DDEBUG
 # to compile with debug, compile like this:
 # make DEBUG="-g3 -DDEBUG"
-CFLAGS = -Wall -Wextra -O2 -I../ziz $(DEBUG)
+VERSION ?= 1.2
+CFLAGS = -Wall -Wextra -O2 -I../ziz -DVERSION=$(VERSION) $(DEBUG)
 CXXFLAGS = $(CFLAGS)
 
 LDFLAGS =
 # LDCOV = -coverage
-LDLIBS = -lstdc++ -lboost_system -lboost_regex -lboost_filesystem libparser.a ../ziz/libziz.a  -lpicosat -lboost_wave-mt $(LDCOV)
+LDLIBS = libparser.a ../ziz/libziz.a -lstdc++ -lboost_system -lboost_regex -lboost_filesystem -lpicosat -lboost_wave-mt $(LDCOV)
 
-PARSEROBJ = CloudContainer.o RsfReader.o KconfigWhitelist.o ConfigurationModel.o	\
-	    ModelContainer.o SatChecker.o CodeSatStream.o BlockDefectAnalyzer.o
+PARSEROBJ = RsfReader.o KconfigWhitelist.o ConfigurationModel.o	\
+		    ModelContainer.o SatChecker.o BlockDefectAnalyzer.o  \
+			ConditionalBlock.o CoverageAnalyzer.o
 
 DEPFILES:=$(patsubst %.o,%.d,$(PARSEROBJ)) undertaker.d
 
 PROGS = undertaker
-TESTPROGS = test-SatChecker
+TESTPROGS = test-SatChecker test-ConditionalBlock
 
 all: ../ziz/libziz.a $(PROGS) $(TESTPROGS)
 
@@ -51,9 +53,9 @@
 	rm -rf *.o *.a *.gcda *.gcno *.d
 
 test-%: test-%.cpp libparser.a
-	$(CXX) $(CXXFLAGS) -o $@ $< -lcheck $(LDFLAGS) $(LDLIBS)
+	$(CXX) $(CXXFLAGS) -g -O0 -o $@ $< -lcheck $(LDFLAGS) $(LDLIBS)
 
-run-libcheck: test-SatChecker
+run-libcheck: $(TESTPROGS)
 	@for t in $^; do ./$$t; done
 
 # coverage analysis will create validation/sched.c.config*
@@ -66,15 +68,16 @@
 	md5sum validation/sched.c.config* | awk '// {print $$1}' | sort | uniq -c \
 		| awk '// { if ($$1 != 1) { print "duplicate solutions found" ; exit 1 } }' \
 		|| md5sum validation/sched.c.config* | sort
-	if grep -q ^CONFIG_IA64 validation/sched.c.config*; then echo "IA64 not selectable!"; false ; fi
+	if grep -q '^CONFIG_IA64=[^n]' validation/sched.c.config*; then echo "IA64 not selectable!"; false ; fi
 	if grep -q ^CONFIG_CHOICE validation/sched.c.config*; then echo "must not contain CONFIG_CHOICE*"; false ; fi
 
 check: $(PROGS) ../ziz/zizler
 	@$(MAKE) -s clean-check
 	@$(MAKE) run-coveragecheck
 	@$(MAKE) -C kconfig-dumps all
-	cd def-tests && ./run-tests
-	cd validation && ./test-suite
+	cd def-tests && env PATH=$(CURDIR):$(PATH) ./run-tests
+	cd coverage-tests && env PATH=$(CURDIR):$(PATH) ./run-tests
+	cd validation && env PATH=$(CURDIR):$(PATH) ./test-suite -t $$(getconf _NPROCESSORS_ONLN)
 	@$(MAKE) -s run-libcheck
 
 clean-check:
