=== debian/changelog ===
undertaker (1.2-1) unstable; urgency=low

  * New upstream release
    * Drop patch again (Merged upstream)

 -- Christoph Egger <christoph@debian.org>  Thu, 25 Aug 2011 11:25:07 +0200
