=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: undertaker
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Christoph Egger <christoph@debian.org>
+Maintainer: Christoph Egger <christoph@debian.org>
 Uploaders: Reinhard Tartler <siretart@tauware.de>
 Build-Depends: debhelper (>= 7.0.50~),
  picosat (>= 913-4~),
@@ -10,6 +9,7 @@
  libboost-regex-dev (>= 1.40),
  libboost-filesystem-dev (>= 1.40),
  libboost-dev (>= 1.40),
+ python-all (>= 2.6.6-3~),
  check
 Standards-Version: 3.9.1
 Homepage: http://vamos.informatik.uni-erlangen.de/trac/undertaker
@@ -20,7 +20,8 @@
 Architecture: any
 Depends: ${shlibs:Depends},
  ${misc:Depends},
- git
+ git,
+ ${python:Depends}
 Description: static code analysis tool checking preprocessor directives
  The undertaker is an preprocessor and configuration analyser. It can
  check the structure of your preprocessor directives against different
